'''
Created on April 2011 for Pyweek
@author: Martin Villalba (aka akira44)
'''

import pygame
import Coworkers
import Tasks
import os
import Repairman
import Globals
import Hero

class Fix(Coworkers.Coworkers):
    """Eight kind of coworker: the fixman
    This coworker fixes the broken equipment"""
    
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        dir = os.path.abspath('data/fix')
        self.frames, self.numframes, self.rect = self.load_frames(dir)
        self.image = self.frames[0]
        self.rick = Repairman.Repairman()
        self.machine = None
        self.todo = None        

    def set_status(self, x, y, todo):
        self.pos = [x,y]
        self.rect.x = x * 60
        self.rect.bottom = (y+1) * 60
        self.todo = todo

    def work_dammit(self):
        self.action = self.STILL
        if(self.rick.is_done()):
            for i in range(0,Globals.mapsize[0]):
                for j in range(1,Globals.mapsize[1]):
                    if Globals.map[i][j]!= None:
                        if not isinstance(Globals.map[i][j], Hero.hero):
                            if Globals.map[i][j].get_broken_status()== True:
                                self.machine = Globals.map[i][j]
                                #print self.machine
            if(self.machine != None):
                self.rick.start(0,1, self.machine, self.todo)

        #return Tasks.Tasks.FIX_THIS
        return Tasks.Tasks.NONE

    def update(self):
        self.rick.update()
    
    def change_broken_status(self, status):
        """Does nothing (if you break the fixer, 
        who will fix the fixer?)"""
        pass
    
    def get_broken_status(self):
        """Returns the status of a fixer"""
        return False